.text
.org 0x0
.globl _start

# THIS CODE IS (C)OPYRIGHTED, YES I MEAN IT THAT WAY,
# BY tmbinc IN 2003.
#
# modified by steven taffs in 2013 to load first page of code
# from a atmel serial flash chip at45db041d

# r2 holds base of hardware registers (0xcc006800) from bl1

_start:
    li   3, 0
    lis  3, 0xd200           # load atmel "read" command into r3
    lis  4, 0
    li   4, 0x35             # write 4 bytes
    lis  5, 0
    li   5, 0x880
    stw  3, 0x0024(2)        # write data into IMM data reg
    stw  5, 0x0014(2)        # set device options (speed etc)
    bl   do_dma
    lis  3, 0                # write 4 dummy zero bytes
    stw  3, 0x0024(2)        # write data into IMM data reg
    bl   do_dma
    li   3, 256              # 256 bytes (one page)
    li   4, 3                # exi dma read
    li   5, 0
    lis  5, 0x8100
    mtlr 5                   # set address to be jumped to (0x81000000)
    stw  5, 0x0018(2)        # set dma target address
    stw  3, 0x001C(2)        # set the length of dma read
do_dma:
    stw  4, 0x0020(2)        # write value to dma control reg (start dma)
wait:
    lwz  5, 0x0020(2)        # read DMA control reg
    rlwinm. 0,5,0,31,31      # extract "in transfer" bit
    bne wait                 # wait until cleared
    blr                      # branch back / to code
